#include "main.h"
#include "ip.h"
#include "mqtt.h"
#include "serial.h"
#include "delay.h"
#include "opensh.h"
//#include "mac.h"


void *serial_usart1(void *arg)
{ 
    printf("serial_usart 1 start\n");
    
    serial_Receive_1();//串口接收1，用于以后读取引脚高低电平

    return NULL; 
}

void *AppExit(void *arg)//2s程序，出现意外2s自动停止
{ 
  
    while(1)
    {    
        unsigned char bufpwm1[3]={gtypeTemp,1,0};
        unsigned char bufpwm2[3]={gtypeTemp,2,0};
        unsigned char bufpwm3[3]={gtypeTemp,3,0};
        unsigned char bufpwm4[3]={gtypeTemp,4,0};
        //unsigned char bufpwm5[3]={gtypeTemp,5,15};
        Delay_Ms(0,100);
        gPwmCount++;
        //printf( "%d\n",gtypeTemp);
        if(gPwmCount>20)
        {
            //printf( "%d\n",gtypeTemp);
        gPwmCount=21;
        
        //serial_Write(bufpwm5);
        serial_Write(bufpwm1);
        serial_Write(bufpwm2);
        serial_Write(bufpwm3);
        serial_Write(bufpwm4);
        
        } 
    }
    
    return NULL; 
}

void *Mqttbeat(void *arg)
{
    printf("Mqttbeat start\n");
   
    Delay_Ms(5,0);
    while(1)
    {
        mqtt_wirte();//心跳，3s一个
        Delay_Ms(3,0);
    }
    
    
    return NULL;
}

void *opensh(void *arg)
{ 
    Delay_Ms(10,0);
     printf("open cam\n");
    opencamsh();//10s后打开火狐游览器并且进入网址
   return NULL; 
}

void *serial_usart2(void *arg)
{ 
    
    printf("serial_usart 2 start\n");
    serial_Receive_2();//启动串口二
    return NULL;

}

void *Mqtt_onnect(void *arg)
{
    Delay_Ms(5,0);
  
    //mqtt_wirte();//mqtt心跳首次发送
    while(1)
    {    
        mqtt_init();//mqtt初始化
        mqtt_create(mosq);//创建mqtt客户端
        mqtt_create(mosq);
        if(mqtt_create(mosq)!=-1)
        {
            mqtt_cycle(mosq);   
        }

        mqtt_clean(mosq);
    }
    return NULL;
}

int main(int argc, char *argv[]) {

       
    gStart=time(NULL);//开始时间戳
   
    serial_Init();//串口初始化

   // get_mac_address("eth0");//获取mac地址

   ipaddr();//获取ip
    //mosquitto_publish(mosq, NULL, "macmqtt", strlen(TOPIC), TOPIC, 0, false);

   
    thread_start(serial_usart1,AppExit,Mqttbeat,serial_usart2,opensh,Mqtt_onnect);
    //mqtt_cycle(mosq);
   

    
    thread_end();

    return EXIT_SUCCESS;
}